﻿Imports System.ComponentModel

Public Class Form1

    Dim watch As Stopwatch = New Stopwatch
    Private WithEvents MTrans As New MediaTranscode(Me)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        With ProgressBar1
            .Minimum = 0
            .Maximum = 100
        End With

        Button1.Enabled = False
        CheckBox1.Enabled = False
        CheckBox2.Enabled = False
        RadioButton1.Enabled = False
        RadioButton2.Enabled = False

        If MTrans.IsInitialized Then
            Button1.Enabled = True
            CheckBox1.Enabled = True
            CheckBox2.Enabled = True
            RadioButton1.Enabled = True
            RadioButton2.Enabled = True

            CheckBox1.Checked = MTrans.AlwaysReencode
            CheckBox2.Checked = MTrans.HardwareAccelerationEnabled

            If MTrans.VideoProcessingAlgorithm = MediaTranscode.MediaVideoProcessingAlgorithm.MediaVideoProcessingAlgorithm_Default Then
                RadioButton1.Checked = True
            Else
                RadioButton2.Checked = True
            End If
        End If

    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        MTrans.Dispose()
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Button1.Enabled = False
        CheckBox1.Enabled = False
        CheckBox2.Enabled = False
        RadioButton1.Enabled = False
        RadioButton2.Enabled = False

        watch.Start()

        'Audio zu Audio
        'Video zu Audio
        MTrans.TranscodeFileToAudio("D:\test_org.mp3", "D:\new.wav", MediaTranscode.AudioProfile.AudioProfile_WAV)

        'Video zu Video
        'Audio zu Video
        'MTrans.TranscodeFileToVideo("D:\test_org.mp4", "D:\new.hevc", MediaTranscode.VideoProfile.VideoProfile_HEVC)

    End Sub

    Private Sub MTrans_CompletedProgress(Value As Double) Handles MTrans.CompletedProgress
        ProgressBar1.Value = CInt(Value)
    End Sub

    Private Sub MTrans_CompletedStatus(Value As MediaTranscode.AsyncStatus) Handles MTrans.CompletedStatus
        Dim strText As String = "Transcoding " & Value.ToString

        If Value <> MediaTranscode.AsyncStatus.Started Then
            watch.Stop()
            strText &= ": Time = " & watch.ElapsedMilliseconds.ToString & " msec"
            Button1.Enabled = True
            CheckBox1.Enabled = True
            CheckBox2.Enabled = True
            RadioButton1.Enabled = True
            RadioButton2.Enabled = True
        End If

        Me.Text = strText

    End Sub

    Private Sub MTrans_FailureReason(Value As MediaTranscode.TranscodeFailureReason) Handles MTrans.FailureReason
        Label1.Text = "FailureReason: " & Value.ToString
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox1.CheckedChanged
        MTrans.AlwaysReencode = CheckBox1.Checked
    End Sub

    Private Sub CheckBox2_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox2.CheckedChanged
        MTrans.HardwareAccelerationEnabled = CheckBox2.Checked
    End Sub

    Private Sub RadioButton1_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton1.CheckedChanged
        MTrans.VideoProcessingAlgorithm = MediaTranscode.MediaVideoProcessingAlgorithm.MediaVideoProcessingAlgorithm_Default
    End Sub

    Private Sub RadioButton2_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton2.CheckedChanged
        MTrans.VideoProcessingAlgorithm = MediaTranscode.MediaVideoProcessingAlgorithm.MediaVideoProcessingAlgorithm_MrfCrf444
    End Sub
End Class
