﻿Imports System.ComponentModel
Imports System.IO
Imports System.Runtime.InteropServices

Public Class MediaTranscode
    Implements IDisposable
    Implements IAsyncActionProgressHandler_Double
    Implements IAsyncActionWithProgressCompletedHandler_Double

#Region "API"
    <DllImport("Combase.dll", EntryPoint:="WindowsCreateString")>
    <PreserveSig> Private Shared Function WindowsCreateString(<[In], MarshalAs(UnmanagedType.LPWStr)> sourceString As String,
                                                              <[In]> length As Integer,
                                                              <Out> ByRef hString As IntPtr) As Integer
    End Function

    <DllImport("Combase.dll", EntryPoint:="WindowsDeleteString")>
    <PreserveSig> Private Shared Function WindowsDeleteString(<[In]> hString As IntPtr) As Integer
    End Function

    <DllImport("Combase.dll", EntryPoint:="RoGetActivationFactory")>
    <PreserveSig> Private Shared Function RoGetActivationFactory(<[In]> activatableClassId As IntPtr,
                                                                 <[In], MarshalAs(UnmanagedType.LPStruct)> riid As Guid,
                                                                 <Out> ByRef factory As IntPtr) As Integer

    End Function

    <DllImport("Combase.dll", EntryPoint:="RoActivateInstance")>
    <PreserveSig> Private Shared Function RoActivateInstance(<[In]> activatableClassId As IntPtr,
                                                             <Out> ByRef instance As IntPtr) As Integer

    End Function

    <DllImport("ShCore.dll", EntryPoint:="CreateRandomAccessStreamOnFile")>
    <PreserveSig> Private Shared Function CreateRandomAccessStreamOnFile(<[In], MarshalAs(UnmanagedType.LPWStr)> filePath As String,
                                                                         <[In]> accessMode As FileAccessMode,
                                                                         <[In], MarshalAs(UnmanagedType.LPStruct)> riid As Guid,
                                                                         <Out> ByRef ppv As IntPtr) As Integer
    End Function

    <DllImport("ShCore.dll", EntryPoint:="CreateRandomAccessStreamOverStream")>
    <PreserveSig> Private Shared Function CreateRandomAccessStreamOverStream(<[In]> pStream As IntPtr,
                                                                             <[In]> options As BSOS_OPTIONS,
                                                                             <[In], MarshalAs(UnmanagedType.LPStruct)> riid As Guid,
                                                                             <Out> ByRef ppv As IntPtr) As Integer
    End Function

    <DllImport("Shlwapi.dll", EntryPoint:="SHCreateStreamOnFileEx")>
    <PreserveSig> Private Shared Function SHCreateStreamOnFileEx(<[In], MarshalAs(UnmanagedType.LPWStr)> pszFile As String,
                                                                 <[In]> grfMode As STGM,
                                                                 <[In]> dwAttributes As Integer,
                                                                 <[In], MarshalAs(UnmanagedType.Bool)> fCreate As Boolean,
                                                                 <[In]> pstmTemplate As IntPtr,
                                                                 <Out> ByRef ppstm As IntPtr) As Integer
    End Function
#End Region

#Region "Enum"
    Private Enum VTable_Interfaces As Integer

        ' IAsyncInfo
        IAsyncInfo_GetID = 6
        IAsyncInfo_GetStatus = 7
        IAsyncInfo_GetErrorCode = 8
        IAsyncInfo_Cancel = 9
        IAsyncInfo_Close = 10

        ' IAsyncInterface
        IAsyncInterface_GetResults = 8

        ' IClosable
        IClosable_Close = 6

        ' IMediaTranscoder
        IMediaTranscoder_PutTrimStartTime = 6
        IMediaTranscoder_GetTrimStartTime = 7
        IMediaTranscoder_PutTrimStopTime = 8
        IMediaTranscoder_GetTrimStopTime = 9
        IMediaTranscoder_PutAlwaysReencode = 10
        IMediaTranscoder_GetAlwaysReencode = 11
        IMediaTranscoder_PutHardwareAccelerationEnabled = 12
        IMediaTranscoder_GetHardwareAccelerationEnabled = 13
        IMediaTranscoder_AddAudioEffect = 14
        IMediaTranscoder_AddAudioEffectWithSettings = 15
        IMediaTranscoder_AddVideoEffect = 16
        IMediaTranscoder_AddVideoEffectWithSettings = 17
        IMediaTranscoder_ClearEffects = 18
        IMediaTranscoder_PrepareFileTranscodeAsync = 19
        IMediaTranscoder_PrepareStreamTranscodeAsync = 20

        ' IMediaTranscoder2
        IMediaTranscoder2_PrepareMediaStreamSourceTranscodeAsync = 6
        IMediaTranscoder2_PutVideoProcessingAlgorithm = 7
        IMediaTranscoder2_GetVideoProcessingAlgorithm = 8

        ' IPrepareTranscodeResult
        IPrepareTranscodeResult_GetCanTranscode = 6
        IPrepareTranscodeResult_GetFailureReason = 7
        IPrepareTranscodeResult_TranscodeAsync = 8

        ' IMediaEncodingProfileStatics
        IMediaEncodingProfileStatics_CreateM4a = 6
        IMediaEncodingProfileStatics_CreateMp3 = 7
        IMediaEncodingProfileStatics_CreateWma = 8
        IMediaEncodingProfileStatics_CreateMp4 = 9
        IMediaEncodingProfileStatics_CreateWmv = 10
        IMediaEncodingProfileStatics_CreateFromFileAsync = 11
        IMediaEncodingProfileStatics_CreateFromStreamAsync = 12

        ' IMediaEncodingProfileStatics2
        IMediaEncodingProfileStatics2_CreateWav = 6
        IMediaEncodingProfileStatics2_CreateAvi = 7

        ' IMediaEncodingProfileStatics3
        IMediaEncodingProfileStatics3_CreateAlac = 6
        IMediaEncodingProfileStatics3_CreateFlac = 7
        IMediaEncodingProfileStatics3_CreateHevc = 8

        ' IAsyncActionWithProgress_Double
        IAsyncActionWithProgress_Double_PutProgress = 6
        IAsyncActionWithProgress_Double_GetProgress = 7
        IAsyncActionWithProgress_Double_PutCompleted = 8
        IAsyncActionWithProgress_Double_GetCompleted = 9
        IAsyncActionWithProgress_Double_GetResults = 10
    End Enum

    Private Enum FileAccessMode As Integer
        Read = 0
        ReadWrite = 1
    End Enum

    Private Enum BSOS_OPTIONS As Integer
        BSOS_DEFAULT = 0
        BSOS_PREFERDESTINATIONSTREAM = 1
    End Enum

    Public Enum AsyncStatus As Integer
        Started = 0
        Completed = 1
        Canceled = 2
        [Error] = 3
    End Enum

    Public Enum TranscodeFailureReason As Integer
        TranscodeFailureReason_None = 0
        TranscodeFailureReason_Unknown = 1
        TranscodeFailureReason_InvalidProfile = 2
        TranscodeFailureReason_CodecNotFound = 3
    End Enum

    Public Enum AudioEncodingQuality As Integer
        AudioEncodingQuality_Auto = 0
        AudioEncodingQuality_High = 1
        AudioEncodingQuality_Medium = 2
        AudioEncodingQuality_Low = 3
    End Enum

    Public Enum VideoEncodingQuality As Integer
        VideoEncodingQuality_Auto = 0
        VideoEncodingQuality_HD1080p = 1
        VideoEncodingQuality_HD720p = 2
        VideoEncodingQuality_Wvga = 3
        VideoEncodingQuality_Ntsc = 4
        VideoEncodingQuality_Pal = 5
        VideoEncodingQuality_Vga = 6
        VideoEncodingQuality_Qvga = 7
        VideoEncodingQuality_Uhd2160p = 8
        VideoEncodingQuality_Uhd4320p = 9
    End Enum

    Public Enum AudioProfile As Integer
        AudioProfile_M4A = 0  'IMediaEncodingProfileStatics
        AudioProfile_MP3 = 1  'IMediaEncodingProfileStatics
        AudioProfile_WMA = 2  'IMediaEncodingProfileStatics
        AudioProfile_WAV = 3  'IMediaEncodingProfileStatics2
        AudioProfile_ALAC = 4 'IMediaEncodingProfileStatics3
        AudioProfile_FLAC = 5 'IMediaEncodingProfileStatics3
    End Enum

    Public Enum VideoProfile As Integer
        VideoProfile_MP4 'IMediaEncodingProfileStatics
        VideoProfile_WMV 'IMediaEncodingProfileStatics
        VideoProfile_AVI 'IMediaEncodingProfileStatics2
        VideoProfile_HEVC 'IMediaEncodingProfileStatics3
    End Enum

    Public Enum MediaVideoProcessingAlgorithm As Integer
        MediaVideoProcessingAlgorithm_Default = 0
        MediaVideoProcessingAlgorithm_MrfCrf444 = 1
    End Enum

    Private Enum STGM As Integer
        STGM_FAILIFTHERE = 0
        STGM_DIRECT = 0
        STGM_READ = 0
        STGM_WRITE = 1
        STGM_READWRITE = 2
        STGM_SHARE_EXCLUSIVE = &H10
        STGM_SHARE_DENY_WRITE = &H20
        STGM_SHARE_DENY_READ = &H30
        STGM_SHARE_DENY_NONE = &H40
        STGM_CREATE = &H1000
        STGM_TRANSACTED = &H10000
        STGM_CONVERT = &H20000
        STGM_PRIORITY = &H40000
        STGM_NOSCRATCH = &H100000
        STGM_NOSNAPSHOT = &H200000
        STGM_DIRECT_SWMR = &H400000
        STGM_SIMPLE = &H8000000
        STGM_DELETEONRELEASE = &H4000000
    End Enum
#End Region

#Region "Const"
    Private Const S_OK As Integer = &H0

    Private Const IID_IClosable As String = "30d5a829-7fa4-4026-83bb-d75bae4ea99e"
    Private Const IID_IAsyncInfo As String = "00000036-0000-0000-c000-000000000046"
    Private Const IID_IRandomAccessStream As String = "905a0fe1-bc53-11df-8c49-001e4fc686da"

    Private Const WindowsMediaTranscodingMediaTranscoder As String = "Windows.Media.Transcoding.MediaTranscoder"
    Private Const IID_IMediaTranscoder As String = "190c99d2-a0aa-4d34-86bc-eed1b12c2f5b"
    Private Const IID_IMediaTranscoder2 As String = "40531d74-35e0-4f04-8574-ca8bc4e5a082"

    Private Const WindowsMediaMediaPropertiesMediaEncodingProfile As String = "Windows.Media.MediaProperties.MediaEncodingProfile"
    Private Const IID_IMediaEncodingProfileStatics As String = "197f352c-2ede-4a45-a896-817a4854f8fe"
    Private Const IID_IMediaEncodingProfileStatics2 As String = "ce8de74f-6af4-4288-8fe2-79adf1f79a43"
    Private Const IID_IMediaEncodingProfileStatics3 As String = "90dac5aa-cf76-4294-a9ed-1a1420f51f6b"

    Private Const IID_IAsyncActionProgressHandler_Double As String = "44825c7c-0da9-5691-b2b4-914f231eeced"
    Private Const IID_IAsyncActionWithProgressCompletedHandler_Double As String = "94d64ac6-4491-53ef-8be8-36481f3ff1e8"
#End Region

#Region "Class"
    Public Sub New(ByVal SyncObject As ISynchronizeInvoke)
        m_SyncObject = SyncObject
        If CreateMediaTranscoder() Then
            If CreateMediaEncodingProfileStatics() Then
                m_bolIsInitialized = True
            End If
        End If
    End Sub
#End Region

#Region "Events"
    Public Event CompletedStatus(Value As AsyncStatus)
    Public Event CompletedProgress(Value As Double)
    Public Event FailureReason(Value As TranscodeFailureReason)
#End Region

#Region "Structure"
    Private Structure TimeSpan
        Dim value As ULong
    End Structure
#End Region

#Region "Variablen"
    Private m_bolDisposedValue As Boolean
    Private m_bolIsInitialized As Boolean
    Private m_bolAlwaysReencode As Boolean
    Private m_bolHardwareAccelerationEnabled As Boolean
    Private m_eMediaVideoProcessingAlgorithm As MediaVideoProcessingAlgorithm

    Private ReadOnly m_SyncObject As ISynchronizeInvoke
    Private ReadOnly m_IAsyncActionProgressHandler_Double_Arg(1) As Object
    Private ReadOnly m_IAsyncActionWithProgressCompletedHandler_Double_Arg(1) As Object

    Private m_pIMediaTranscoder As IntPtr
    Private m_pIMediaTranscoder2 As IntPtr

    Private m_pIMediaEncodingProfile As IntPtr
    Private m_pIMediaEncodingProfile2 As IntPtr
    Private m_pIMediaEncodingProfile3 As IntPtr

    Private m_pIMediaEncodingProfileStatics As IntPtr
    Private m_pIMediaEncodingProfileStatics2 As IntPtr
    Private m_pIMediaEncodingProfileStatics3 As IntPtr

    Private m_pTmpIStream As IntPtr
    Private m_pTmpIRandomAccessStreamIn As IntPtr
    Private m_pTmpIRandomAccessStreamOut As IntPtr
    Private m_pTmpIMediaEncodingProfile As IntPtr
    Private m_pTmpIPrepareTranscodeResult As IntPtr
    Private m_pTmpIAsyncActionWithProgress_Double As IntPtr
#End Region

#Region "Properties"
    Public ReadOnly Property IsInitialized As Boolean
        Get
            Return m_bolIsInitialized
        End Get
    End Property

    Public Property VideoProcessingAlgorithm As MediaVideoProcessingAlgorithm
        Get
            Return m_eMediaVideoProcessingAlgorithm
        End Get
        Set(value As MediaVideoProcessingAlgorithm)
            If Me.IsInitialized Then
                If MediaTranscoder2_PutVideoProcessingAlgorithm(m_pIMediaTranscoder2, value) Then
                    m_eMediaVideoProcessingAlgorithm = value
                End If
            End If
        End Set
    End Property

    Public Property AlwaysReencode As Boolean
        Get
            Return m_bolAlwaysReencode
        End Get
        Set(value As Boolean)
            If Me.IsInitialized Then
                If MediaTranscoder_PutAlwaysReencode(m_pIMediaTranscoder, value) Then
                    m_bolAlwaysReencode = value
                End If
            End If
        End Set
    End Property

    Public Property HardwareAccelerationEnabled As Boolean
        Get
            Return m_bolHardwareAccelerationEnabled
        End Get
        Set(value As Boolean)
            If Me.IsInitialized Then
                If MediaTranscoder_PutHardwareAccelerationEnabled(m_pIMediaTranscoder, value) Then
                    m_bolHardwareAccelerationEnabled = value
                End If
            End If
        End Set
    End Property
#End Region

#Region "Public Functions"
    Public Sub TranscodeFileToAudio(FileIn As String,
                                    FileOut As String,
                                    Profile As AudioProfile,
                                    Optional EncodingQuality As AudioEncodingQuality = AudioEncodingQuality.AudioEncodingQuality_High)
        Dim bolOk As Boolean = False
        Dim strFileExt As String = Path.GetExtension(FileOut).ToLower
        If Me.IsInitialized AndAlso File.Exists(FileIn) Then
            Select Case Profile
                Case AudioProfile.AudioProfile_M4A
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".mp4" Then FileOut &= ".m4a"
                    If MediaEncodingProfileStatics_CreateM4a(m_pIMediaEncodingProfileStatics,
                                                             EncodingQuality,
                                                             m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case AudioProfile.AudioProfile_MP3
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".mp3" Then FileOut &= ".mp3"
                    If MediaEncodingProfileStatics_CreateMp3(m_pIMediaEncodingProfileStatics,
                                                             EncodingQuality,
                                                             m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case AudioProfile.AudioProfile_WMA
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".wma" Then FileOut &= ".wma"
                    If MediaEncodingProfileStatics_CreateWma(m_pIMediaEncodingProfileStatics,
                                                             EncodingQuality,
                                                             m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case AudioProfile.AudioProfile_WAV
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".wav" Then FileOut &= ".wav"
                    ' Bug! AudioEncodingQuality_Auto geht nicht für WAV
                    If EncodingQuality = AudioEncodingQuality.AudioEncodingQuality_Auto Then EncodingQuality = AudioEncodingQuality.AudioEncodingQuality_High
                    If MediaEncodingProfileStatics2_CreateWav(m_pIMediaEncodingProfileStatics2,
                                                              EncodingQuality,
                                                              m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case AudioProfile.AudioProfile_ALAC
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".alac" Then FileOut &= ".alac"
                    If MediaEncodingProfileStatics3_CreateAlac(m_pIMediaEncodingProfileStatics3,
                                                               EncodingQuality,
                                                               m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case AudioProfile.AudioProfile_FLAC
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".flac" Then FileOut &= ".flac"
                    If MediaEncodingProfileStatics3_CreateFlac(m_pIMediaEncodingProfileStatics3,
                                                               EncodingQuality,
                                                               m_pTmpIMediaEncodingProfile) Then bolOk = True
            End Select
            If bolOk Then
                bolOk = False
                If LoadAndCreateFiles(FileIn, FileOut) Then
                    If MediaTranscoder_PrepareStreamTranscodeAsync(m_pIMediaTranscoder, m_pTmpIRandomAccessStreamIn,
                                                                   m_pTmpIRandomAccessStreamOut, m_pTmpIMediaEncodingProfile,
                                                                   m_pTmpIPrepareTranscodeResult) Then
                        If WaitForAsync(m_pTmpIPrepareTranscodeResult) Then
                            Dim bolCanTranscode As Boolean
                            If PrepareTranscodeResult_GetCanTranscode(m_pTmpIPrepareTranscodeResult, bolCanTranscode) Then
                                If bolCanTranscode Then
                                    RaiseEvent CompletedProgress(0D)
                                    RaiseEvent CompletedStatus(AsyncStatus.Started)
                                    If PrepareTranscodeResult_TranscodeAsync(m_pTmpIPrepareTranscodeResult,
                                                                             m_pTmpIAsyncActionWithProgress_Double) Then
                                        If AsyncActionWithProgress_Double_PutProgress(m_pTmpIAsyncActionWithProgress_Double, Me) Then

                                            If AsyncActionWithProgress_Double_PutCompleted(m_pTmpIAsyncActionWithProgress_Double, Me) Then
                                                bolOk = True
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
        If Not bolOk Then
            ReleaseTmpInterfaces()
            File.Delete(FileOut)
        End If
    End Sub

    Public Sub TranscodeFileToVideo(FileIn As String,
                                    FileOut As String,
                                    Profile As VideoProfile,
                                    Optional EncodingQuality As VideoEncodingQuality = VideoEncodingQuality.VideoEncodingQuality_HD1080p)
        Dim bolOk As Boolean = False
        Dim strFileExt As String = Path.GetExtension(FileOut).ToLower
        If Me.IsInitialized AndAlso File.Exists(FileIn) Then
            Select Case Profile
                Case VideoProfile.VideoProfile_MP4
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".mp4" Then FileOut &= ".mp4"
                    If MediaEncodingProfileStatics_CreateMp4(m_pIMediaEncodingProfileStatics,
                                                             EncodingQuality,
                                                             m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case VideoProfile.VideoProfile_WMV
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".wmv" Then FileOut &= ".wmv"
                    If MediaEncodingProfileStatics_CreateWmv(m_pIMediaEncodingProfileStatics,
                                                             EncodingQuality,
                                                             m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case VideoProfile.VideoProfile_AVI
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".avi" Then FileOut &= ".avi"
                    If MediaEncodingProfileStatics2_CreateAvi(m_pIMediaEncodingProfileStatics2,
                                                              EncodingQuality,
                                                              m_pTmpIMediaEncodingProfile) Then bolOk = True
                Case VideoProfile.VideoProfile_HEVC
                    If String.IsNullOrEmpty(strFileExt) OrElse strFileExt <> ".hevc" Then FileOut &= ".hevc"
                    If MediaEncodingProfileStatics3_CreateHevc(m_pIMediaEncodingProfileStatics3,
                                                               EncodingQuality,
                                                               m_pTmpIMediaEncodingProfile) Then bolOk = True
            End Select
            If bolOk Then
                bolOk = False
                If LoadAndCreateFiles(FileIn, FileOut) Then
                    If MediaTranscoder_PrepareStreamTranscodeAsync(m_pIMediaTranscoder, m_pTmpIRandomAccessStreamIn,
                                                                   m_pTmpIRandomAccessStreamOut, m_pTmpIMediaEncodingProfile,
                                                                   m_pTmpIPrepareTranscodeResult) Then
                        If WaitForAsync(m_pTmpIPrepareTranscodeResult) Then
                            Dim bolCanTranscode As Boolean
                            If PrepareTranscodeResult_GetCanTranscode(m_pTmpIPrepareTranscodeResult, bolCanTranscode) Then
                                If bolCanTranscode Then
                                    RaiseEvent CompletedProgress(0D)
                                    RaiseEvent CompletedStatus(AsyncStatus.Started)
                                    If PrepareTranscodeResult_TranscodeAsync(m_pTmpIPrepareTranscodeResult,
                                                                             m_pTmpIAsyncActionWithProgress_Double) Then
                                        If AsyncActionWithProgress_Double_PutProgress(m_pTmpIAsyncActionWithProgress_Double, Me) Then
                                            If AsyncActionWithProgress_Double_PutCompleted(m_pTmpIAsyncActionWithProgress_Double, Me) Then
                                                bolOk = True
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
        If Not bolOk Then
            ReleaseTmpInterfaces()
            File.Delete(FileOut)
        End If
    End Sub
#End Region

#Region "Private Functions"
    Private Function CreateMediaTranscoder() As Boolean
        Dim bolRet As Boolean = False
        If GetActivateInstance(WindowsMediaTranscodingMediaTranscoder,
                               IID_IMediaTranscoder, m_pIMediaTranscoder) Then
            If QueryInterface(m_pIMediaTranscoder, IID_IMediaTranscoder2,
                              m_pIMediaTranscoder2) Then
                If MediaTranscoder_GetAlwaysReencode(m_pIMediaTranscoder,
                                                     m_bolAlwaysReencode) Then
                    If MediaTranscoder_GetHardwareAccelerationEnabled(m_pIMediaTranscoder,
                                                         m_bolHardwareAccelerationEnabled) Then
                        If MediaTranscoder2_GetVideoProcessingAlgorithm(m_pIMediaTranscoder2,
                                                                        m_eMediaVideoProcessingAlgorithm) Then
                            bolRet = True
                        End If
                    End If
                End If
            End If
        End If
        Return bolRet
    End Function

    Private Function CreateMediaEncodingProfileStatics() As Boolean
        Dim bolRet As Boolean = False
        If GetActivationFactory(WindowsMediaMediaPropertiesMediaEncodingProfile,
                                IID_IMediaEncodingProfileStatics, m_pIMediaEncodingProfileStatics) Then
            If QueryInterface(m_pIMediaEncodingProfileStatics, IID_IMediaEncodingProfileStatics2,
                              m_pIMediaEncodingProfileStatics2) Then
                If QueryInterface(m_pIMediaEncodingProfileStatics2, IID_IMediaEncodingProfileStatics3,
                                  m_pIMediaEncodingProfileStatics3) Then
                    bolRet = True
                End If
            End If
        End If
        Return bolRet
    End Function

    Private Function LoadAndCreateFiles(FileIn As String,
                                        FileOut As String) As Boolean
        Dim bolRet As Boolean = False
        If CreateRandomAccessStreamOnFile(FileIn, FileAccessMode.Read,
                                          New Guid(IID_IRandomAccessStream),
                                          m_pTmpIRandomAccessStreamIn) = S_OK Then
            If SHCreateStreamOnFileEx(FileOut, STGM.STGM_CREATE Or STGM.STGM_READWRITE,
                                      0, False, IntPtr.Zero, m_pTmpIStream) = S_OK Then
                If CreateRandomAccessStreamOverStream(m_pTmpIStream, BSOS_OPTIONS.BSOS_DEFAULT,
                                                      New Guid(IID_IRandomAccessStream),
                                                      m_pTmpIRandomAccessStreamOut) = S_OK Then
                    bolRet = True
                End If
            End If
        End If
        Return bolRet
    End Function

    Private Sub ReleaseTmpInterfaces()
        Release(m_pTmpIAsyncActionWithProgress_Double)
        Dim eTranscodeFailureReason As TranscodeFailureReason
        If PrepareTranscodeResult_GetFailureReason(m_pTmpIPrepareTranscodeResult, eTranscodeFailureReason) Then RaiseEvent FailureReason(eTranscodeFailureReason)
        Release(m_pTmpIPrepareTranscodeResult)
        Release(m_pTmpIMediaEncodingProfile)
        CloseAndRelease(m_pTmpIRandomAccessStreamOut)
        Release(m_pTmpIStream)
        CloseAndRelease(m_pTmpIRandomAccessStreamIn)
    End Sub

    Private Function GetActivationFactory(ClassName As String,
                                          IID As String,
                                          ByRef pFactory As IntPtr) As Boolean
        Dim bolRet As Boolean = False
        Dim hString As IntPtr = IntPtr.Zero
        If WindowsCreateString(ClassName, ClassName.Length, hString) = S_OK Then
            If hString <> IntPtr.Zero Then
                If RoGetActivationFactory(hString, New Guid(IID), pFactory) = S_OK Then bolRet = True
                WindowsDeleteString(hString)
            End If
        End If
        Return bolRet
    End Function

    Private Function GetActivateInstance(ClassName As String,
                                         IID As String,
                                         ByRef pInstance As IntPtr) As Boolean
        Dim bolRet As Boolean = False
        Dim hString As IntPtr = IntPtr.Zero
        If WindowsCreateString(ClassName, ClassName.Length, hString) = S_OK Then
            If hString <> IntPtr.Zero Then
                Dim pIInspectable As IntPtr = IntPtr.Zero
                If RoActivateInstance(hString, pIInspectable) = S_OK Then
                    If pIInspectable <> IntPtr.Zero Then
                        If QueryInterface(pIInspectable, IID, pInstance) Then
                            If pInstance <> IntPtr.Zero Then bolRet = True
                        End If
                        Release(pIInspectable)
                    End If
                End If
                WindowsDeleteString(hString)
            End If
        End If
        Return bolRet
    End Function

    Private Function WaitForAsync(ByRef pInterface As IntPtr) As Boolean
        Dim bolret As Boolean = False
        If pInterface <> IntPtr.Zero Then
            Dim pIAsyncInfo As IntPtr = IntPtr.Zero
            If QueryInterface(pInterface, IID_IAsyncInfo, pIAsyncInfo) Then
                Dim eStatus As AsyncStatus
                Do
                    AsyncInfo_GetStatus(pIAsyncInfo, eStatus)
                Loop While eStatus = AsyncStatus.Started
                If eStatus = AsyncStatus.Completed Then
                    bolret = True
                Else
                    AsyncInfo_Close(pIAsyncInfo)
                End If
                Release(pIAsyncInfo)
                If bolret Then
                    Dim pRet As IntPtr = IntPtr.Zero
                    If AsyncInterface_GetResults(pInterface, pRet) Then
                        Release(pInterface)
                        pInterface = pRet
                    End If
                End If
            End If
        End If
        Return bolret
    End Function

    Private Function GetVTablePtr(pInterface As IntPtr,
                                  intMethodNumber As VTable_Interfaces,
                                  ByRef pVTablePtr As IntPtr) As Boolean
        Dim bolRet As Boolean = False
        If pInterface <> IntPtr.Zero AndAlso intMethodNumber >= 0 Then
            Dim pVTablePtrs As IntPtr() = New IntPtr(0) {}
            Marshal.Copy(IntPtr.Add(Marshal.ReadIntPtr(pInterface),
                                    IntPtr.Size * intMethodNumber),
                                    pVTablePtrs, 0, 1)
            pVTablePtr = pVTablePtrs(0)
            bolRet = True
        End If
        Return bolRet
    End Function

    Private Sub Release(ByRef pInterface As IntPtr)
        If pInterface <> IntPtr.Zero Then
            Marshal.Release(pInterface)
            pInterface = IntPtr.Zero
        End If
    End Sub

    Private Sub CloseAndRelease(ByRef pInterface As IntPtr)
        If pInterface <> IntPtr.Zero Then
            Dim pIClosable As IntPtr = IntPtr.Zero
            If QueryInterface(pInterface, IID_IClosable, pIClosable) Then
                If Closable_Close(pIClosable) Then
                    Marshal.Release(pIClosable)
                    Marshal.Release(pInterface)
                    pInterface = IntPtr.Zero
                End If
            End If
        End If
    End Sub

    Private Function QueryInterface(pInterface As IntPtr,
                                    IID As String,
                                    ByRef pIOut As IntPtr) As Boolean
        Dim bolRet As Boolean = False
        If pInterface <> IntPtr.Zero Then
            If Marshal.QueryInterface(pInterface, New Guid(IID), pIOut) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function
#End Region

#Region "Interface Delegates"

    Private Delegate Function IMediaTranscoder_PutTrimStartTime(<[In]> this As IntPtr,
                                                                <[In]> value As TimeSpan) As Integer

    Private Delegate Function IMediaTranscoder_GetTrimStartTime(<[In]> this As IntPtr,
                                                                <Out> ByRef value As TimeSpan) As Integer
    Private Delegate Function IMediaTranscoder_PutTrimStopTime(<[In]> this As IntPtr,
                                                               <[In]> value As TimeSpan) As Integer

    Private Delegate Function IMediaTranscoder_GetTrimStopTime(<[In]> this As IntPtr,
                                                               <Out> ByRef value As TimeSpan) As Integer

    Private Delegate Function IMediaTranscoder_PutAlwaysReencode(<[In]> this As IntPtr,
                                                                 <[In], MarshalAs(UnmanagedType.Bool)> value As Boolean) As Integer

    Private Delegate Function IMediaTranscoder_GetAlwaysReencode(<[In]> this As IntPtr,
                                                                 <Out, MarshalAs(UnmanagedType.Bool)> ByRef value As Boolean) As Integer

    Private Delegate Function IMediaTranscoder_PutHardwareAccelerationEnabled(<[In]> this As IntPtr,
                                                                              <[In], MarshalAs(UnmanagedType.Bool)> value As Boolean) As Integer

    Private Delegate Function IMediaTranscoder_GetHardwareAccelerationEnabled(<[In]> this As IntPtr,
                                                                              <Out, MarshalAs(UnmanagedType.Bool)> ByRef value As Boolean) As Integer

    Private Delegate Function IMediaTranscoder_AddAudioEffect(<[In]> this As IntPtr,
                                                              <[In]> activatableClassId As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder_AddAudioEffectWithSettings(<[In]> this As IntPtr,
                                                                          <[In]> activatableClassId As IntPtr,
                                                                          <[In], MarshalAs(UnmanagedType.Bool)> effectRequired As Boolean,
                                                                          <[In]> configuration As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder_AddVideoEffect(<[In]> this As IntPtr,
                                                              <[In]> activatableClassId As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder_AddVideoEffectWithSettings(<[In]> this As IntPtr,
                                                                          <[In]> activatableClassId As IntPtr,
                                                                          <[In], MarshalAs(UnmanagedType.Bool)> effectRequired As Boolean,
                                                                          <[In]> configuration As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder_ClearEffects(<[In]> this As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder_PrepareFileTranscodeAsync(<[In]> this As IntPtr,
                                                                         <[In]> source As IntPtr,
                                                                         <[In]> destination As IntPtr,
                                                                         <[In]> profile As IntPtr,
                                                                         <Out> ByRef operation As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder_PrepareStreamTranscodeAsync(<[In]> this As IntPtr,
                                                                          <[In]> source As IntPtr,
                                                                          <[In]> destination As IntPtr,
                                                                          <[In]> profile As IntPtr,
                                                                          <Out> ByRef operation As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder2_PrepareMediaStreamSourceTranscodeAsync(<[In]> this As IntPtr,
                                                                                       <[In]> source As IntPtr,
                                                                                       <[In]> destination As IntPtr,
                                                                                       <[In]> profile As IntPtr,
                                                                                       <Out> ByRef operation As IntPtr) As Integer

    Private Delegate Function IMediaTranscoder2_PutVideoProcessingAlgorithm(<[In]> this As IntPtr,
                                                                            <[In]> value As MediaVideoProcessingAlgorithm) As Integer

    Private Delegate Function IMediaTranscoder2_GetVideoProcessingAlgorithm(<[In]> this As IntPtr,
                                                                            <Out> ByRef value As MediaVideoProcessingAlgorithm) As Integer

    Private Delegate Function IPrepareTranscodeResult_GetCanTranscode(<[In]> this As IntPtr,
                                                                      <Out, MarshalAs(UnmanagedType.Bool)> ByRef value As Boolean) As Integer

    Private Delegate Function IPrepareTranscodeResult_GetFailureReason(<[In]> this As IntPtr,
                                                                      <Out> ByRef value As TranscodeFailureReason) As Integer

    Private Delegate Function IPrepareTranscodeResult_TranscodeAsync(<[In]> this As IntPtr,
                                                                      <Out> ByRef operation As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics_CreateM4a(<[In]> this As IntPtr,
                                                                     <[In]> quality As AudioEncodingQuality,
                                                                     <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics_CreateMp3(<[In]> this As IntPtr,
                                                                     <[In]> quality As AudioEncodingQuality,
                                                                     <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics_CreateWma(<[In]> this As IntPtr,
                                                                     <[In]> quality As AudioEncodingQuality,
                                                                     <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics_CreateMp4(<[In]> this As IntPtr,
                                                                     <[In]> quality As VideoEncodingQuality,
                                                                     <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics_CreateWmv(<[In]> this As IntPtr,
                                                                     <[In]> quality As VideoEncodingQuality,
                                                                     <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics_CreateFromFileAsync(<[In]> this As IntPtr,
                                                                               <[In]> file As IntPtr,
                                                                               <Out> ByRef operation As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics_CreateFromStreamAsync(<[In]> this As IntPtr,
                                                                                 <[In]> stream As IntPtr,
                                                                                 <Out> ByRef operation As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics2_CreateWav(<[In]> this As IntPtr,
                                                                      <[In]> quality As AudioEncodingQuality,
                                                                      <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics2_CreateAvi(<[In]> this As IntPtr,
                                                                      <[In]> quality As VideoEncodingQuality,
                                                                      <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics3_CreateAlac(<[In]> this As IntPtr,
                                                                       <[In]> quality As AudioEncodingQuality,
                                                                       <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics3_CreateFlac(<[In]> this As IntPtr,
                                                                       <[In]> quality As AudioEncodingQuality,
                                                                       <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IMediaEncodingProfileStatics3_CreateHevc(<[In]> this As IntPtr,
                                                                       <[In]> quality As VideoEncodingQuality,
                                                                       <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IAsyncActionWithProgress_Double_PutProgress(<[In]> this As IntPtr,
                                                                          <[In], MarshalAs(UnmanagedType.Interface)> handler As IAsyncActionProgressHandler_Double) As Integer

    Private Delegate Function IAsyncActionWithProgress_Double_GetProgress(<[In]> this As IntPtr,
                                                                          <Out, MarshalAs(UnmanagedType.Interface)> ByRef result As IAsyncActionProgressHandler_Double) As Integer

    Private Delegate Function IAsyncActionWithProgress_Double_PutCompleted(<[In]> this As IntPtr,
                                                                          <[In], MarshalAs(UnmanagedType.Interface)> handler As IAsyncActionWithProgressCompletedHandler_Double) As Integer

    Private Delegate Function IAsyncActionWithProgress_Double_GetCompleted(<[In]> this As IntPtr,
                                                                          <Out, MarshalAs(UnmanagedType.Interface)> ByRef result As IAsyncActionWithProgressCompletedHandler_Double) As Integer

    Private Delegate Function IAsyncActionWithProgress_Double_GetResults(<[In]> this As IntPtr) As Integer

    Private Delegate Function IAsyncInfo_GetStatus(<[In]> this As IntPtr,
                                                    <Out> ByRef status As AsyncStatus) As Integer

    Private Delegate Function IAsyncInfo_Close(<[In]> this As IntPtr) As Integer

    Private Delegate Function IAsyncInterface_GetResults(<[In]> this As IntPtr,
                                                         <Out> ByRef results As IntPtr) As Integer

    Private Delegate Function IClosable_Close(<[In]> this As IntPtr) As Integer
#End Region

#Region "Interface Functions"
    Private Function MediaTranscoder_PutTrimStartTime(this As IntPtr,
                                                      value As TimeSpan) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_PutTrimStartTime, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_PutTrimStartTime)),
                                                           IMediaTranscoder_PutTrimStartTime).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_GetTrimStartTime(this As IntPtr,
                                                      ByRef value As TimeSpan) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_GetTrimStartTime, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_GetTrimStartTime)),
                                                           IMediaTranscoder_GetTrimStartTime).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function
    Private Function MediaTranscoder_PutTrimStopTime(this As IntPtr,
                                                     value As TimeSpan) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_PutTrimStopTime, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_PutTrimStopTime)),
                                                           IMediaTranscoder_PutTrimStopTime).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_GetTrimStopTime(this As IntPtr,
                                                     ByRef value As TimeSpan) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_GetTrimStopTime, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_GetTrimStopTime)),
                                                           IMediaTranscoder_GetTrimStopTime).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_PutAlwaysReencode(this As IntPtr,
                                                       value As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_PutAlwaysReencode, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_PutAlwaysReencode)),
                                                           IMediaTranscoder_PutAlwaysReencode).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_GetAlwaysReencode(this As IntPtr,
                                                       ByRef value As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_GetAlwaysReencode, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_GetAlwaysReencode)),
                                                           IMediaTranscoder_GetAlwaysReencode).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_PutHardwareAccelerationEnabled(this As IntPtr,
                                                                    value As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_PutHardwareAccelerationEnabled, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_PutHardwareAccelerationEnabled)),
                                                           IMediaTranscoder_PutHardwareAccelerationEnabled).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_GetHardwareAccelerationEnabled(this As IntPtr,
                                                                    ByRef value As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_GetHardwareAccelerationEnabled, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_GetHardwareAccelerationEnabled)),
                                                           IMediaTranscoder_GetHardwareAccelerationEnabled).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_AddAudioEffect(this As IntPtr,
                                                    activatableClassId As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_AddAudioEffect, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_AddAudioEffect)),
                                                           IMediaTranscoder_AddAudioEffect).Invoke(this, activatableClassId) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_AddAudioEffectWithSettings(this As IntPtr,
                                                                activatableClassId As IntPtr,
                                                                effectRequired As Boolean,
                                                                configuration As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_AddAudioEffectWithSettings, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_AddAudioEffectWithSettings)),
                                                           IMediaTranscoder_AddAudioEffectWithSettings).Invoke(this, activatableClassId, effectRequired, configuration) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_AddVideoEffect(this As IntPtr,
                                                    activatableClassId As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_AddVideoEffect, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_AddVideoEffect)),
                                                           IMediaTranscoder_AddVideoEffect).Invoke(this, activatableClassId) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_AddVideoEffectWithSettings(this As IntPtr,
                                                                activatableClassId As IntPtr,
                                                                effectRequired As Boolean,
                                                                configuration As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_AddVideoEffectWithSettings, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_AddVideoEffectWithSettings)),
                                                           IMediaTranscoder_AddVideoEffectWithSettings).Invoke(this, activatableClassId, effectRequired, configuration) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_ClearEffects(this As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_ClearEffects, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_ClearEffects)),
                                                           IMediaTranscoder_ClearEffects).Invoke(this) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_PrepareFileTranscodeAsync(this As IntPtr,
                                                               source As IntPtr,
                                                               destination As IntPtr,
                                                               profile As IntPtr,
                                                               ByRef operation As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_PrepareFileTranscodeAsync, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_PrepareFileTranscodeAsync)),
                                                           IMediaTranscoder_PrepareFileTranscodeAsync).Invoke(this, source, destination, profile, operation) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder_PrepareStreamTranscodeAsync(this As IntPtr,
                                                                 source As IntPtr,
                                                                 destination As IntPtr,
                                                                 profile As IntPtr,
                                                                 ByRef operation As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder_PrepareStreamTranscodeAsync, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder_PrepareStreamTranscodeAsync)),
                                                           IMediaTranscoder_PrepareStreamTranscodeAsync).Invoke(this, source, destination, profile, operation) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder2_PrepareMediaStreamSourceTranscodeAsync(this As IntPtr,
                                                                             source As IntPtr,
                                                                             destination As IntPtr,
                                                                             profile As IntPtr,
                                                                             ByRef operation As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder2_PrepareMediaStreamSourceTranscodeAsync, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder2_PrepareMediaStreamSourceTranscodeAsync)),
                                                           IMediaTranscoder2_PrepareMediaStreamSourceTranscodeAsync).Invoke(this, source, destination, profile, operation) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder2_PutVideoProcessingAlgorithm(this As IntPtr,
                                                                  value As MediaVideoProcessingAlgorithm) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder2_PutVideoProcessingAlgorithm, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder2_PutVideoProcessingAlgorithm)),
                                                           IMediaTranscoder2_PutVideoProcessingAlgorithm).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaTranscoder2_GetVideoProcessingAlgorithm(this As IntPtr,
                                                                  ByRef value As MediaVideoProcessingAlgorithm) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaTranscoder2_GetVideoProcessingAlgorithm, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaTranscoder2_GetVideoProcessingAlgorithm)),
                                                           IMediaTranscoder2_GetVideoProcessingAlgorithm).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function PrepareTranscodeResult_GetCanTranscode(this As IntPtr,
                                                            ByRef value As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IPrepareTranscodeResult_GetCanTranscode, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IPrepareTranscodeResult_GetCanTranscode)),
                                                           IPrepareTranscodeResult_GetCanTranscode).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function PrepareTranscodeResult_GetFailureReason(this As IntPtr,
                                                             ByRef value As TranscodeFailureReason) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IPrepareTranscodeResult_GetFailureReason, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IPrepareTranscodeResult_GetFailureReason)),
                                                           IPrepareTranscodeResult_GetFailureReason).Invoke(this, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function PrepareTranscodeResult_TranscodeAsync(this As IntPtr,
                                                           ByRef operation As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IPrepareTranscodeResult_TranscodeAsync, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IPrepareTranscodeResult_TranscodeAsync)),
                                                           IPrepareTranscodeResult_TranscodeAsync).Invoke(this, operation) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function


    Private Function MediaEncodingProfileStatics_CreateM4a(this As IntPtr,
                                                           quality As AudioEncodingQuality,
                                                           ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics_CreateM4a, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics_CreateM4a)),
                                                           IMediaEncodingProfileStatics_CreateM4a).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics_CreateMp3(this As IntPtr,
                                                           quality As AudioEncodingQuality,
                                                           ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics_CreateMp3, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics_CreateMp3)),
                                                           IMediaEncodingProfileStatics_CreateMp3).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics_CreateWma(this As IntPtr,
                                                           quality As AudioEncodingQuality,
                                                           ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics_CreateWma, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics_CreateWma)),
                                                           IMediaEncodingProfileStatics_CreateWma).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics_CreateMp4(this As IntPtr,
                                                           quality As VideoEncodingQuality,
                                                           ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics_CreateMp4, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics_CreateMp4)),
                                                           IMediaEncodingProfileStatics_CreateMp4).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics_CreateWmv(this As IntPtr,
                                                           quality As VideoEncodingQuality,
                                                           ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics_CreateWmv, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics_CreateWmv)),
                                                           IMediaEncodingProfileStatics_CreateWmv).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics_CreateFromFileAsync(this As IntPtr,
                                                                     file As IntPtr,
                                                                     ByRef operation As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics_CreateFromFileAsync, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics_CreateFromFileAsync)),
                                                           IMediaEncodingProfileStatics_CreateFromFileAsync).Invoke(this, file, operation) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics_CreateFromStreamAsync(this As IntPtr,
                                                                       stream As IntPtr,
                                                                       ByRef operation As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics_CreateFromStreamAsync, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics_CreateFromStreamAsync)),
                                                           IMediaEncodingProfileStatics_CreateFromStreamAsync).Invoke(this, stream, operation) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics2_CreateWav(this As IntPtr,
                                                            quality As AudioEncodingQuality,
                                                            ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics2_CreateWav, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics2_CreateWav)),
                                                           IMediaEncodingProfileStatics2_CreateWav).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics2_CreateAvi(this As IntPtr,
                                                            quality As VideoEncodingQuality,
                                                            ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics2_CreateAvi, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics2_CreateAvi)),
                                                           IMediaEncodingProfileStatics2_CreateAvi).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics3_CreateAlac(this As IntPtr,
                                                             quality As AudioEncodingQuality,
                                                             ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics3_CreateAlac, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics3_CreateAlac)),
                                                           IMediaEncodingProfileStatics3_CreateAlac).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics3_CreateFlac(this As IntPtr,
                                                             quality As AudioEncodingQuality,
                                                             ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics3_CreateFlac, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics3_CreateFlac)),
                                                           IMediaEncodingProfileStatics3_CreateFlac).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function MediaEncodingProfileStatics3_CreateHevc(this As IntPtr,
                                                             quality As VideoEncodingQuality,
                                                             ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IMediaEncodingProfileStatics3_CreateHevc, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IMediaEncodingProfileStatics3_CreateHevc)),
                                                           IMediaEncodingProfileStatics3_CreateHevc).Invoke(this, quality, value) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function


    Private Function AsyncActionWithProgress_Double_PutProgress(this As IntPtr,
                                                                handler As IAsyncActionProgressHandler_Double) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncActionWithProgress_Double_PutProgress, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncActionWithProgress_Double_PutProgress)),
                                                           IAsyncActionWithProgress_Double_PutProgress).Invoke(this, handler) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function AsyncActionWithProgress_Double_GetProgress(this As IntPtr,
                                                                ByRef result As IAsyncActionProgressHandler_Double) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncActionWithProgress_Double_GetProgress, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncActionWithProgress_Double_GetProgress)),
                                                           IAsyncActionWithProgress_Double_GetProgress).Invoke(this, result) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function AsyncActionWithProgress_Double_PutCompleted(this As IntPtr,
                                                                 handler As IAsyncActionWithProgressCompletedHandler_Double) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncActionWithProgress_Double_PutCompleted, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncActionWithProgress_Double_PutCompleted)),
                                                           IAsyncActionWithProgress_Double_PutCompleted).Invoke(this, handler) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function AsyncActionWithProgress_Double_GetCompleted(this As IntPtr,
                                                                 ByRef result As IAsyncActionWithProgressCompletedHandler_Double) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncActionWithProgress_Double_GetCompleted, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncActionWithProgress_Double_GetCompleted)),
                                                           IAsyncActionWithProgress_Double_GetCompleted).Invoke(this, result) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function AsyncActionWithProgress_Double_GetResults(this As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncActionWithProgress_Double_GetResults, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncActionWithProgress_Double_GetResults)),
                                                           IAsyncActionWithProgress_Double_GetResults).Invoke(this) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function


    Private Function AsyncInfo_GetStatus(this As IntPtr,
                                         ByRef status As AsyncStatus) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncInfo_GetStatus, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncInfo_GetStatus)),
                                                           IAsyncInfo_GetStatus).Invoke(this, status) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function AsyncInfo_Close(this As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncInfo_Close, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncInfo_Close)),
                                                           IAsyncInfo_Close).Invoke(this) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function AsyncInterface_GetResults(this As IntPtr,
                                               ByRef results As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncInterface_GetResults, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncInterface_GetResults)),
                                                           IAsyncInterface_GetResults).Invoke(this, results) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function

    Private Function Closable_Close(this As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim bolRet As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IClosable_Close, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IClosable_Close)),
                                                           IClosable_Close).Invoke(this) = S_OK Then bolRet = True
        End If
        Return bolRet
    End Function
#End Region

#Region "Implements IDisposable"
    Protected Overridable Sub Dispose(disposing As Boolean)
        If Not m_bolDisposedValue Then
            If disposing Then
            End If
            Release(m_pIMediaEncodingProfileStatics3)
            Release(m_pIMediaEncodingProfileStatics2)
            Release(m_pIMediaEncodingProfileStatics)
            Release(m_pIMediaEncodingProfile3)
            Release(m_pIMediaEncodingProfile2)
            Release(m_pIMediaEncodingProfile)
            Release(m_pIMediaTranscoder2)
            Release(m_pIMediaTranscoder)
            m_bolIsInitialized = False
            m_bolDisposedValue = True
        End If
    End Sub

    Public Sub Dispose() Implements IDisposable.Dispose
        Dispose(disposing:=True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region

#Region "Interface IAsyncActionProgressHandler_Double"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IAsyncActionProgressHandler_Double)>
    Private Interface IAsyncActionProgressHandler_Double
        <PreserveSig> Function Invoke(<[In]> asyncInfo As IntPtr, <[In]> progressInfo As Double) As Integer
    End Interface
#End Region

#Region "Implements IAsyncActionProgressHandler_Double"

    Private Delegate Sub IAsyncActionProgressHandler_Double_Invoke_Delegate(<[In]> asyncInfo As IntPtr, <[In]> progressInfo As Double)

    Private ReadOnly IAsyncActionProgressHandler_Double_Invoke As New IAsyncActionProgressHandler_Double_Invoke_Delegate(AddressOf IAsyncActionProgressHandler_Double_Invoke_Sub)

    Private Sub IAsyncActionProgressHandler_Double_Invoke_Sub(<[In]> asyncInfo As IntPtr, <[In]> progressInfo As Double)
        RaiseEvent CompletedProgress(progressInfo)
    End Sub

    Private Function IAsyncActionProgressHandlerDoubleInvoke(<[In]> asyncInfo As IntPtr, <[In]> progressInfo As Double) As Integer Implements IAsyncActionProgressHandler_Double.Invoke

        m_IAsyncActionProgressHandler_Double_Arg(0) = asyncInfo
        m_IAsyncActionProgressHandler_Double_Arg(1) = progressInfo

        m_SyncObject.BeginInvoke(IAsyncActionProgressHandler_Double_Invoke, m_IAsyncActionProgressHandler_Double_Arg)

        Return S_OK
    End Function
#End Region

#Region "Interface IAsyncActionWithProgressCompletedHandler_Double"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IAsyncActionWithProgressCompletedHandler_Double)>
    Private Interface IAsyncActionWithProgressCompletedHandler_Double
        <PreserveSig> Function Invoke(<[In]> asyncInfo As IntPtr, <[In]> asyncStatus As AsyncStatus) As Integer
    End Interface
#End Region

#Region "Implements IAsyncActionWithProgressCompletedHandler_Double"

    Private Delegate Sub IAsyncActionWithProgressCompletedHandler_Double_Invoke_Delegate(<[In]> asyncInfo As IntPtr, <[In]> asyncStatus As AsyncStatus)

    Private ReadOnly IAsyncActionWithProgressCompletedHandler_Double_Invoke As New IAsyncActionWithProgressCompletedHandler_Double_Invoke_Delegate(AddressOf IAsyncActionWithProgressCompletedHandler_Double_Invoke_Sub)

    Private Sub IAsyncActionWithProgressCompletedHandler_Double_Invoke_Sub(<[In]> asyncInfo As IntPtr, <[In]> asyncStatus As AsyncStatus)
        RaiseEvent CompletedStatus(asyncStatus)
        If asyncStatus <> AsyncStatus.Started Then ReleaseTmpInterfaces()
    End Sub

    Private Function IAsyncActionWithProgressCompletedHandlerDoubleInvoke(<[In]> asyncInfo As IntPtr, <[In]> asyncStatus As AsyncStatus) As Integer Implements IAsyncActionWithProgressCompletedHandler_Double.Invoke

        m_IAsyncActionWithProgressCompletedHandler_Double_Arg(0) = asyncInfo
        m_IAsyncActionWithProgressCompletedHandler_Double_Arg(1) = asyncStatus

        m_SyncObject.BeginInvoke(IAsyncActionWithProgressCompletedHandler_Double_Invoke, m_IAsyncActionWithProgressCompletedHandler_Double_Arg)

        Return S_OK
    End Function
#End Region

End Class
